function plot_clust_evo_3D(clu,ax,opt_draw)
% Input
%   clu:        a cluster structure created with init_clust()  
%   ax:         an axis handler where the graphics is displayed
%   opt_draw:   

[~, comp] = pca(clu.train_samples);
%comp = eye(3);
shapes = ['+' 's' 'x' 'd' 'v' '^' '<' '>' 'p' 'h' '+' 's' 'x' 'd' 'v' '^' '<' '>' 'p' 'h'];

cla(ax);
axes(ax);
hold on;

% Nominal cluster
for clust = 1:clu.n_clust_nor
    pc = comp * clu.points_nor{clust}';
    plot3(pc(1,:),pc(2,:),pc(3,:),'o','Color',pick_color('n'));
    if opt_draw.labels == 1
        labels = cellstr(num2str(clu.time_nor{clust}'));
        text(pc(1,:),pc(2,:),pc(3,:), labels);
    end
    if not(isempty(clu.added_point_nor)) && size(clu.added_point_nor,2) >= clust && ...
        not(isempty(clu.added_point_nor{clust}))
        pc_add = comp * clu.added_point_nor{clust}';
        plot3(pc_add(1,:),pc_add(2,:),pc_add(3,:),'o','Color',pick_color('n'));
        if opt_draw.labels == 1
            labels = cellstr(num2str(clu.added_time_nor{clust}'));
            text(pc_add(1,:),pc_add(2,:),pc_add(3,:), labels);
        end        
    end
end

% Faulty cluster
for clust = 1:clu.n_clust_fau
    pc = comp * clu.points_fau{clust}';
    plot3(pc(1,:),pc(2,:),pc(3,:),shapes(clust),'Color',pick_color('f',clust));
    if opt_draw.labels == 1
        labels = cellstr(num2str(clu.time_fau{clust}'));
        text(pc(1,:),pc(2,:),pc(3,:), labels);
    end
    if not(isempty(clu.added_point_fau)) && size(clu.added_point_fau,2) >= clust && ...
        not(isempty(clu.added_point_fau{clust}))
        pc_add = comp * clu.added_point_fau{clust}';
        plot3(pc_add(1,:),pc_add(2,:),pc_add(3,:),shapes(clust),'Color',pick_color('f',clust));
        if opt_draw.labels == 1
            labels = cellstr(num2str(clu.added_time_fau{clust}'));
            text(pc_add(1,:),pc_add(2,:),pc_add(3,:), labels);
        end
    end
end

% Outliers
if not(isempty(clu.outliers))
    dime1 = size(clu.outliers,1);
    dime2 = size(clu.outliers,2);
    data = zeros(dime1,dime2);
    for outl = 1:dime1
        data(outl,:) = clu.outliers(outl,:);
    end
    pc = comp * data';
    plot3(pc(1,:),pc(2,:),pc(3,:),'*','Color',pick_color('o'));
    if opt_draw.labels == 1
        labels = cellstr(num2str(clu.outliers_time'));
        text(pc(1,:),pc(2,:),pc(3,:), labels);
    end
end

%Change marker size
h = findall(gca,'marker','o');
set(h,'MarkerSize',12);
set(h,'LineWidth',2);
%inspect(h)
h = findall(gca,'marker','*');
set(h,'MarkerSize',14)
set(h,'LineWidth',2);
for i = 1:10
    h = findall(gca,'marker',shapes(i));
    set(h,'MarkerSize',14);
    set(h,'LineWidth',2);
end
