function err = NRMSE(y,y_target)


% Method for computing the normalized root-mean-square error
% Note: the formula is:
% err = sqrt(||y - y_target ||^2 / ||y_target - E(y_target) ||) where E is
% the mean value

% INPUT
% y: estimated output
% y_target: real output

%OUTPUT
% err: normalized root-mean-square error

if length(y) ~= length(y_target)
    error('The two output length is not equal');
else
    err = sqrt( sum((y - y_target).^2) / sum((y_target - mean(y_target)).^2));
end
