function class = class_fds(clu)
% Input
%   clu:    a cluster structure created from init_clust()
% Output
% class:    vector conatining the ordered classification ofthe parameter
%           vectors processed in clu
%           0       Outliers
%           1       Nominal sample
%           2-Inf   Faulty clusters

% Initialization as nominal cluster
class = ones(1,clu.n_points);

% Faulty clusters
for clust = 1:clu.n_clust_fau
    for samp = 1:clu.n_points_fau(clust)
        class(clu.time_fau{clust}(samp)) = 1 + clust;
    end
    if not(isempty(clu.added_point_fau)) && size(clu.added_point_fau,2) >= clust && ...
        not(isempty(clu.added_point_fau{clust}))
        for added = 1:size(clu.added_point_fau{clust},1)
            class(clu.added_time_fau{clust}(added)) = 1 + clust;
        end
    end
end

% Outlier set
if not(isempty(clu.outliers))
    for outl = 1:clu.n_outl
        class(clu.outliers_time(outl)) = 0;
    end
end
