function [cogn_result, detection_relationship] = cognitive_fds(model, opt_hmm, n_train)
% todo: pensare se ha ancora senso
n_rel = length(model);
n_valid = floor(n_train * (1 - opt_hmm.valid_perc));
n_samples = length(model(1).datas);

detection_relationship = zeros(n_rel,n_samples);


cogn_result.det_rel = zeros(1,n_samples); 
cogn_result.env_change = zeros(1,n_samples);
cogn_result.sens_fault = zeros(1,n_samples);
cogn_result.det_bias = zeros(1,n_samples);
cogn_result.fault = zeros(1,n_samples);
cogn_result.unconsistent = zeros(1,n_samples);

for ii = n_valid:n_samples
    H = zeros(n_rel,1);
    env_change = zeros(n_rel,1);
    sens_fault = zeros(n_rel,1);
    fault = zeros(n_rel,1);
    det_bias = zeros(n_rel,1);
    
    for jj = 1:n_rel
        H(jj) = model(jj).loglikelihoods(ii) < model(jj).threshold_change;
        if H(jj) == 1
            detection_relationship(jj,ii) = 1;

            Sunrelated = 0; %Sp
            Tunrelated = 0; %Tp

            Splus = 0; %S+
            Tplus = 0; %T+

            Sminus = 0; %S-
            Tminus = 0; %T-

            changed_input = model(jj).inputI;
            changed_output = model(jj).outputI;

        % COMPUTE Ss and Ts
            for kk = 1:n_rel
                node_input = model(kk).inputI;
                node_output = model(kk).outputI;
                if kk ~= jj
                    if (changed_input == node_input) || (changed_input == node_output)
                        Splus = Splus + model(kk).loglikelihoods(ii);
                        Tplus = Tplus + model(kk).avg_lls - opt_hmm.c_ce * model(jj).inf_bound;
                    elseif (changed_output == node_input) || (changed_output == node_output)
                        Sminus = Sminus + model(kk).loglikelihoods(ii);
                        Tminus = Tminus + model(kk).avg_lls - opt_hmm.c_ce * model(jj).inf_bound;
                    else
                        Sunrelated = Sunrelated + model(kk).loglikelihoods(ii);
                        Tunrelated = Tunrelated + model(kk).avg_lls - opt_hmm.c_ce * model(jj).inf_bound;
                    end
                end
            end

            if Sunrelated < Tunrelated
                env_change(jj) = 1;
            elseif ((Splus < Tplus) && (Sminus < Tminus))
                sens_fault(jj) = -1;
                fault(jj) = 1;
            elseif Splus < Tplus
                sens_fault(jj) = changed_input;
                fault(jj) = 1;
            elseif Sminus < Tminus
                sens_fault(jj) = changed_output;
                fault(jj) = 1;
            else
                det_bias(jj) = 1;
            end
        end 
    end
    
    if sum(H) > 0
        if ~sum(H) == max([sum(env_change) sum(fault) sum(det_bias)])
            fprintf('%s\n','Unconsistent fault or change detected. No decision is taken.');
            cogn_result.unconsistent(ii) = 1;
        else
            if sum(H) == sum(env_change)
                fprintf('Change in the environment at sample %d \n', ii);
                cogn_result.env_change(ii) = 1;
            elseif sum(H) == sum(det_bias)
                fprintf('Model bias of relationship %d -> %d at sample %d \n', changed_input, changed_output, ii);
                cogn_result.det_bias(ii) = 1;
            elseif sum(H) == sum(fault)
                faulty_sens = setdiff(unique(sens_fault(logical(H))),-1);
                if length(unique(fault(logical(H)))) > 1 || length(faulty_sens) > 1
                    fprintf(['Unconsistent fault detected at sample' num2str(ii) ' (sensors', mat2str(faulty_sens),...
                        ' involved). No decision is taken.\n']);
                    cogn_result.unconsistent(ii) = 1;
                else
                    cogn_result.fault(ii) = 1;
                    if unique(sens_fault(logical(H))) == -1
                        fprintf('Fault detected at sample %d \n',ii);
                        cogn_result.sens_fault(ii) = -1;
                    else 
                        fprintf('Fault detected in unit %d at sample %d \n', faulty_sens, ii);
                        cogn_result.sens_fault(ii) = faulty_sens;
                        cogn_result.fault(ii) = 1;
                    end
                end
            end
        end     
    end
end
