function [tot_fn tot_fp tot_dd det_rela] = detection_net(fn,fp,dd,indexes,fau_sensor)


n_max_rel = size(indexes,1);
n_nodes = (1 + sqrt(1 + 4 * n_max_rel)) / 2;


if fau_sensor <= n_nodes
    dispos = dispositions(n_nodes);
    int_rel = (dispos(:,1) == fau_sensor) + (dispos(:,2) == fau_sensor);
    int_rel = int_rel(indexes);
else
    int_rel = ones(sum(indexes),1);
end
int_rel = logical(int_rel);

fn_chos = fn(int_rel);
fp_chos = fp(int_rel);
dd_chos = dd(int_rel);

tot_fn = 0;
tot_fp = 0;
tot_dd = NaN;
det_rela = 0;

if sum(fp_chos) > 0
    tot_fp = 1;
elseif sum(fn_chos) < sum(int_rel)
    [tot_dd ind_rela] = nanmin(dd_chos);
    det_rela = find(cumsum(int_rel) == ind_rela,1);
else
    tot_fn = 1;
end
