function [fn fp dd] = hmm_single_detection(model,aggr,init_fau,opt_hmm,varargin)
if nargin > 4
    apost_thereshold = varargin{1};
end

if ~isempty(aggr)
    model = aggr_lls(model,aggr);
end

valid_lls = model.loglikelihoods(:,opt_hmm.n_hmm_cdt_train:opt_hmm.n_hmm_cdt_valid);
test_lls = model.loglikelihoods(:,(opt_hmm.n_hmm_cdt_valid+1):(end-1));
avg_lls = mean(valid_lls,2);
min_val = min(valid_lls,[],2);
bound = avg_lls - min_val;
len_test = length(test_lls);

threshold_change = avg_lls - opt_hmm.c * bound;
if strcmp(aggr,'apost')
    det = test_lls <= repmat(threshold_change,1,len_test);
    det = mean(det) >= apost_thereshold;
else
    det = test_lls <= threshold_change;
end
det_indexes = find(det == 1,1);
delay = det_indexes - init_fau + opt_hmm.n_hmm_cdt_valid;
if isempty(det_indexes)
    fn = 1;
    fp = 0;
    dd = NaN;
elseif delay >=0
    dd = delay;
    fp = 0;
    fn = 0;
else
    fp = 1;
    fn = 0;
    dd = NaN;
end
