function [isol_delay isol] = hmm_single_isolation(model, aggr, fault_time, detection_time, opt_hmm, varargin)

len_test = size(model(1).loglikelihoods,2)-(fault_time+detection_time);
n_model = length(model);

if strcmp(aggr,'apost')
    apost_threshold = varargin{1};
    [n_ens n_data] = size(model(1).loglikelihoods);    
    tot_lls = zeros(n_ens * n_model, n_data);
    for ii = 1:length(model)
        tot_lls(1+(ii-1)*n_ens:ii*n_ens,:) = model(ii).loglikelihoods;
    end
    valid_lls = tot_lls(:,opt_hmm.n_hmm_cdt_train:opt_hmm.n_hmm_cdt_valid);
    lls = tot_lls(:,(fault_time+detection_time):(end-1));

    avg_lls = mean(valid_lls,2);
    min_val = min(valid_lls,[],2);

    norm_lls = (lls - repmat(avg_lls,1,len_test)) ./ (repmat(avg_lls,1,len_test) - repmat(min_val,1,len_test));
    isol = norm_lls <= repmat(-opt_hmm.c_i,n_ens * n_model, len_test);
    isol = mean(isol) >= apost_threshold;
else
    incr_lls = zeros(1, len_test);
    for ii = 1:length(model)

        if ~isempty(aggr)
            model(ii) = aggr_lls(model(ii),aggr);
        end
        valid_lls = model(ii).loglikelihoods(:,opt_hmm.n_hmm_cdt_train:opt_hmm.n_hmm_cdt_valid);
        lls = model(ii).loglikelihoods(:,(fault_time+detection_time):(end-1));
        avg_lls = mean(valid_lls,2);
        min_val = min(valid_lls,[],2);

        incr_lls = incr_lls + (lls - avg_lls) / (avg_lls - min_val);
    end
    isol = (incr_lls / length(model)) <= -opt_hmm.c_i;
end

isol_delay = find(isol == 1,1);

