function [lls lls_index] = test_hmm(features,hmm,feature_data_index,opt_hmm)

n_feat = size(features,1);
feat_dim = floor((n_feat - opt_hmm.par_window) / opt_hmm.par_step);

% Creates windows of features and estimate loglikelihhod on each of them
lls = zeros(feat_dim,opt_hmm.dim_ens);
lls_index = zeros(feat_dim,2);

init_index = zeros(1,feat_dim);
final_index = zeros(1,feat_dim);

feat_set = cell(feat_dim,1);

for ii = 1:feat_dim
    init_index(ii) = (ii-1) * opt_hmm.par_step + 1;
    final_index(ii) = (ii-1) * opt_hmm.par_step + opt_hmm.par_window;
    feat_set{ii} = features(init_index(ii):final_index(ii),:)';
    lls_index(ii,1) = feature_data_index(init_index(ii),1);
    lls_index(ii,2) = feature_data_index(final_index(ii),2);
    
    for jj = 1:opt_hmm.dim_ens
        lls(ii,jj) = mhmm_logprob(feat_set{ii}, hmm(jj).prior, hmm(jj).transmat,...
            hmm(jj).mu, hmm(jj).Sigma, hmm(jj).mixmat);
    end
end

% for ii = 1:feat_dim    
%     for jj = 1:opt_hmm.dim_ens
%         if ~isfinite(lls(ii,jj))
%             % Needed for plot...-Inf is not displayed
%             cons_data = lls(isfinite(lls(:,jj)),jj);
%             min_val = min(cons_data);
%             std_dev = std(cons_data);
%             lls(ii,jj) = min_val - 10 * std_dev;
%         end
%     end
% end
