function model = test_hmm_fds(model, data, opt_hmm)


if isempty(model(1).hmm)
    n_model = 0;
else
    n_model = length(model);
end

n_lls_data = opt_hmm.data_window + opt_hmm.data_step * (opt_hmm.par_window - 1);

for jj = 1:n_model
    % Test the hmm on validation and test sets
    init_sample = opt_hmm.n_hmm_cdt_train - n_lls_data;
    assert(init_sample > 0);
    input = data(init_sample:end,model(jj).inputI);
    output = data(init_sample:end,model(jj).outputI);

    fprintf('Testing relationship between the sensors (input -> output): %d -> %d\n', model(jj).inputI,model(jj).outputI);
    
    [features feature_data_index] = hmm_feature_extraction(input, output, opt_hmm, model(jj).order);
    features = (features - repmat(model(jj).mu,size(features,1),1)) ./ repmat(model(jj).sigma,size(features,1),1);
    [lls lls_index] = test_hmm(features,model(jj).hmm,feature_data_index,opt_hmm);
    init_index = lls_index(:,2) + init_sample;
    final_index = lls_index(2:end,2) + init_sample - 1;
    final_index = [final_index; size(data,1)];
    
    assert(sum(final_index - init_index < 0) == 0);

    feat_dim = size(lls,1); 
    data_lls = zeros(opt_hmm.dim_ens,size(data,1));
    for ii = 1:feat_dim
        data_lls(:,init_index(ii):final_index(ii)) = repmat(lls(ii,:)',1,final_index(ii)-init_index(ii)+1);
    end
    % Saving loglikelihood and meaningful information
    model(jj).datas = data;
    model(jj).theta = features;
    model(jj).loglikelihoods = data_lls;
end
