function [valid_lls hmm] = train_hmm(train_features,valid_features,n_states,n_gauss)

n_coeff = size(train_features,1);
cov_type = 'diag';

prior0 = normalise(rand(n_states,1));
transmat0 = mk_stochastic(rand(n_states,n_states));
[mu0, Sigma0] = mixgauss_init(n_states*n_gauss, train_features, cov_type);
mu0 = reshape(mu0, [n_coeff n_states n_gauss]);
Sigma0 = reshape(Sigma0, [n_coeff n_coeff n_states n_gauss]);
mixmat0 = mk_stochastic(rand(n_states,n_gauss));


[~, hmm.prior, hmm.transmat, hmm.mu, hmm.Sigma, hmm.mixmat] = ...
    mhmm_em(train_features, prior0, transmat0, mu0, Sigma0, mixmat0, 'max_iter', 10, 'verbose', 0);

valid_lls = mhmm_logprob(valid_features, hmm.prior, hmm.transmat,...
    hmm.mu, hmm.Sigma, hmm.mixmat);
