function plot_graph(ax,adj,names,colors,layout)

% colors.node = {[0 0.4 1]};
% colors.edge = {};

axis(ax,[0 1 0 1]);
cla(ax);
addtosystempath('C:\Program Files (x86)\Graphviz2.34\bin');

if isempty(layout)
    layout = Circlelayout;
end

if isempty(colors)
    colors = [];
    colors.node = {[0 0.8 1]};
    colors.edge = {};
end

n_col_edges = size(colors.edge,1);
assert(mod(size(colors.edge,2),3) == 0);
if isempty(names) && ~isempty(colors.edge)
    edgeColors = cell(n_col_edges,3);
    for i = 1:n_col_edges
        edgeColors{i,1} = ['x_{' num2str(colors.edge{i,1}) '}'];
        edgeColors{i,2} = ['x_{' num2str(colors.edge{i,2}) '}'];
        edgeColors{i,3} = colors.edge{i,3};        
    end
else
    edgeColors = colors.edge;
end

if isempty(names)
    names = cell(1,size(adj,1));
    for i = 1:size(adj,1)
        names{i}= ['x_{' num2str(i) '}'];
    end
end


nodeColors = colors.node;
graphViz4Matlab('-adjMat',adj               ,...
                '-nodeLabels',names         ,...
                '-layout',layout            ,...
                '-nodeColors',nodeColors    ,...
                '-edgeColors',edgeColors    ,...
                '-specifyAxes',ax           );
