function plot_hmm_cognitive(fig,data,n_train,cogn_result,FontSize)

gca(fig);
n_samples = length(cogn_result.env_change);
x = n_train:n_samples;


if ~isempty(data)
    [~, mu, sigma] = zscore(data(1:n_train,:));
    data = (data - repmat(mu,size(data,1),1)) ./ repmat(sigma,size(data,1),1);
    subplot(5,1,1);
    plot(x,data(n_train:end,:)); axis tight;
    title('Dataset','FontSize',FontSize);
    set(gca,'FontSize',FontSize);
end

subplot(5,1,2);
plot(x,cogn_result.env_change(n_train:end),'LineWidth',2) %plotting faults likelihood drop occurrences in E^P
title('Environmental change','FontSize',FontSize); axis tight; ylim([0 1.2]);
set(gca,'FontSize',FontSize);
subplot(5,1,3);
plot(x,cogn_result.fault(n_train:end),'LineWidth',2) %plotting faults likelihood drop occurrences in E^+ or E^-
hold on;
plot(x,cogn_result.unconsistent(n_train:end),'r','LineWidth',2) %plotting faults likelihood drop occurrences in E^+ or E^-
title('Faults','FontSize',FontSize); axis tight; ylim([0 1.2]);
set(gca,'FontSize',FontSize);
subplot(5,1,4);
plot(x,cogn_result.sens_fault(n_train:end),'LineWidth',2) %plotting faults likelihood drop occurrences in E^+ or E^-
title('Faulty unit','FontSize',FontSize); grid on; axis tight; ylim([-1.2 size(data,2)+0.2]);
set(gca,'FontSize',FontSize);
subplot(5,1,5);
plot(x,cogn_result.det_bias(n_train:end),'LineWidth',2); 
title('Model bias','FontSize',FontSize); axis tight; ylim([0 1.2]);
set(gca,'FontSize',FontSize);
