function plot_lls(fig,model,n_train,n_valid,varargin)

lim_min = Inf;
lim_max = -Inf;
for i = 1:length(model)
    cons_lls = model(i).loglikelihoods(:,1:n_train);
    cons_lls = cons_lls(cons_lls ~= 0);
    variation = 12*max(std(cons_lls));
    lls_mean = mean(cons_lls(:));
    temp_lim_min = lls_mean - variation;
    temp_lim_max = lls_mean + variation;
    if lim_min > temp_lim_min
        lim_min = temp_lim_min;
    end
    if lim_max < temp_lim_max
        lim_max = temp_lim_max;
    end
end
y_limits = [lim_min lim_max];

if nargin > 4
    plot_title = varargin{1};
end

gcf(fig);
col = colormap('HSV');
n_rel = length(model);
indexes = round((1:n_rel) /n_rel * size(col,1));
lege = cell(n_rel,1);
if isempty(fig)
    figure();
end
for i = 1 : length(model)
    plot(model(i).loglikelihoods','Color',col(indexes(i),:));
    lege{i} = [num2str(model(i).inputI) ' -> ' num2str(model(i).outputI)];
    hold on;
    grid on;
    axis tight;
    ylim(y_limits);
end
plot([n_train n_train],y_limits,'k--');
plot([n_valid n_valid],y_limits,'r--');

if nargin  > 5
    plot([varargin{2} varargin{2}],y_limits,'g--');
end

legend(lege,'Location','SouthWest');
if nargin  > 4
    title(plot_title);
end
