function visualize_lls(fig,model,n_train,n_valid,varargin)

y_limits = [-10 5];
for i = 1:length(model)
    cons_lls = model(i).loglikelihoods(:,n_valid:n_train);
    lls_mean = mean(cons_lls(:));
    lls_min = min(cons_lls(:));
    bound = lls_mean - lls_min;
    model(i).loglikelihoods = (model(i).loglikelihoods - lls_mean) / bound;
end

if nargin > 4
    plot_title = varargin{1};
end

gcf(fig);
col = colormap('HSV');
n_rel = length(model);
indexes = round((1:n_rel) /n_rel * size(col,1));
lege = cell(n_rel,1);
if isempty(fig)
    figure();
end

for i = 1 : length(model)
    plot(model(i).loglikelihoods','Color',col(indexes(i),:));
    lege{i} = [num2str(model(i).inputI) ' -> ' num2str(model(i).outputI)];
    hold on;
    grid on;
    axis tight;
end

ylim(y_limits);
plot([n_train n_train],y_limits,'k--');
plot([n_valid n_valid],y_limits,'r--');

for i = 1:10
    plot([1 size(model(1).loglikelihoods',1)],[-i -i],'--');
end

if nargin  > 5
    plot([varargin{2} varargin{2}],y_limits,'g--');
end

legend(lege,'Location','SouthWest');
if nargin  > 4
    title(plot_title);
end
