function M = windowize(data, window_length, frame_length, weights)
% M = windowize(data, window_length, frame_length, weights)
% 
% Windowizes a signal, (last frame is cutted if not complete)

assert( size(data,2) == 1);
if nargin < 2
    window_length = 256;
end % default 256
if nargin < 3
    frame_length = fix(window_length / 2);
end % default wl/2

data_length = size(data,1);
n_frames = floor((data_length - window_length)/frame_length)+1;
lines = (1:window_length)';
cols = 0:frame_length:(n_frames-1)*frame_length;
M = data(lines(:,ones(1,n_frames)) + cols(ones(window_length,1),:));

if nargin == 4
    if size(weights,2) ~= 1
        weights = weights';
    end
    M = weights(:,ones(1,n_frames)).*M;
end
