function net_part(x_train,ind_var)

n_rel = size(chosen_rel,1);

% Parameter vectors extraction (with batch standardization)
max_aord = max(ordersSel(:,1));
max_bord = max(ordersSel(:,2));
max_kord = max(ordersSel(:,3));
max_eff_batch = max([max_aord, max_bord + max_kord]) + opt.batch;
n_train_batch = floor(opt.n_train / max_eff_batch );

theta = cell(1,n_rel);
for jj = 1:n_rel
    input = y{chosen_rel(jj,1)};
    output = y{chosen_rel(jj,2)};
    batch = max_eff_batch - max([ordersSel(jj,1),ordersSel(jj,2)+ordersSel(jj,3)]);
    theta{jj} = parameter_extraction(output, input, batch, ordersSel(jj,:));
end
fprintf('%s\n','Parameter vectors estimated');

%% Extract features
[x_train x_test ind_var] = feature_extraction(theta,n_train_batch,feature_type);

P = zeros(n_rel);
pval = ones(n_rel);
alpha_ind = 0.05;

for i = 1:n_rel
    X = x_train(:,ind_var{i});
    for k = 1:(i-1)
        Y = x_train(:,ind_var{k});
            [pval(i,k) stat(i,k)] = UInd_KCItest(X, Y, 0);
            P(i,k) = pval(i,k) < alpha_ind;
            P(k,i) = P(i,k);
            pval(k,i) = pval(i,k);
    end
end

dep_subset = find_dep_subsets(P);

figure();
ax = axes();
colors.node = {[0 0.4 1]};
colors.edge = {};
plot_graph(ax,pval < alpha_ind,[],colors,[])

for i = 1:n_rel
    figure();
    plot([x_train(:,ind_var{i}); x_test(:,ind_var{i})]);
    title(['Rel. ' num2str(chosen_rel(i,1)) ' --> ' num2str(chosen_rel(i,2))])
end
