function  [feature_sequence feature_cov resid] = parameter_extraction(output, input, batch, const_input, arx_order)

if size(input,1) < size(input,2)
    input = input';
end

if size(output,1) < size(output,2)
    output = output';
end

na = arx_order(1);
nb = arx_order(2);
nk = arx_order(3);

eff_batch = batch + max([na nb+nk]);
n_feat = floor(length(output) / eff_batch);
n_input = size(input,2);

% Model estimation 
feature_sequence = zeros(n_feat,na + nb * n_input + const_input);
feature_cov = cell(n_feat,1);

resid = zeros(n_feat,batch);
for ii = 1:n_feat
    init_index = 1 + (ii-1) * eff_batch;
    fin_index = ii * eff_batch;

    cons_input = input(init_index:fin_index,:);
    cons_output = output(init_index:fin_index,:);

    opt_est.eff_batch = length(cons_output);
    opt_est.aord = na;
    opt_est.bord = nb;
    opt_est.kord = nk;
    opt_est.n_input = 1;
    opt_est.max_ord = max([na nb+nk]);
    opt_est.batch = batch;

    opt_est.mode = 'arx';
    opt_est.res_anal = 0;
    opt_est.const_input = const_input;
    
    model = model_creation(cons_input',cons_output',opt_est);

    feature_sequence(ii,:) = model.res_fau';
    feature_cov{ii} = model.param_cov;
    
    resid(ii,:) = model.residuals;
end

resid = resid(:);
