function [H pval] = test_exog_total(theta,theta_cov,resid,n_train,arx_order,const_input,alpha)

if isempty(alpha)
    alpha = 0.05;
end

n_rel = length(theta);

for i = 1:n_rel
    assert(size(theta{i},2) == arx_order(i,1) + arx_order(i,2)+const_input);
end

t_stat = zeros(n_rel,1);
pval = zeros(n_rel,1);

for i = 1:n_rel
    p_tot = arx_order(i,1) + arx_order(i,2) + const_input;
    p_exo = arx_order(i,2) + const_input;
    RSS = sum(resid{i}(:,1).^2) ;
    regr_features = theta{i}(:,(arx_order(i,1)+1):end);
    sigma{i} = theta_cov{i}{1};
    inv_sigma{i} = inv(sigma{i});
    inv_exog{i} = inv(inv_sigma{i}((arx_order(i,1)+1):end,(arx_order(i,1)+1):end));
    t_stat(i) = (n_train - p_tot) / p_exo / RSS * regr_features * inv_exog{i} * regr_features';
    pval(i) = 1 - fcdf(t_stat(i), p_exo, n_train - p_tot);
end
H = pval < alpha;
