function [opt_fau fau_data] = inject_fault_net(data,location,opt_output,opt_fau)
% INJECT_FAULT_NET inject the fault specified by OPT_FAU in a datastream of
% DATA, in the sensor specified by LOCATION
%
%   Input:
%       data: a multivariate stream of data (samples * variables)
%       location: index of the sensor (or sensors) where the fault will be
%           injected
%       opt_output: structure specifying the structure of the generated
%           datastreams
%       opt_fau: structure specifying the fault signature (see FAULT_GENERATION
%           for details)
%
%   Output:
%       fau_data: faulty datastreams
%       opt_fau: structure specifying the fault signature (see FAULT_GENERATION
%           for details)

assert(size(data,2) < size(data,1));

fau_data = data;
for ii = 1:length(location)
    [yf opt_fau] = fault_generation([],data(:,location(ii))',opt_output,opt_fau);
    fau_data(:,location(ii)) = yf';
end
