function opt_est = ar_order_estimation(y,opt_est)

assert(opt_est.train_est_perc > 0 && opt_est.train_est_perc < 1);
%Training and validation set extraction
n_train_sam = floor(opt_est.not_fault * opt_est.train_est_perc);
y_train = y(1:n_train_sam);
y_valid = y(n_train_sam+1:opt_est.not_fault);

data_train = iddata(y_train');
data_valid = iddata(y_valid');

%ARX
err_valid = zeros(opt_est.max_ord_expl,1);
for a_ord = 2:opt_est.max_ord_expl
    arx_mod = arx(data_train,a_ord); %If you do not provide x, it is an AR model
    pred_valid = predict(arx_mod,data_valid,1);
        if strcmp(opt_est.val,'AIC')
            err_valid(a_ord) = n_train_sam * log(sum((pred_valid.OutputData - y_valid').^2) / n_train_sam) + 2 * a_ord;
        elseif strcmp(opt_est.val,'BIC')
            err_valid(a_ord) =  log(sum((pred_valid.OutputData - y_valid').^2) / n_train_sam) + log(n_train_sam) * a_ord;
        elseif strcmp(opt_est.val,'MDL')
            err_valid(a_ord,b_ord) =  sum((pred_valid.OutputData - y_valid').^2) * (1 + (a_ord) / n_train_sam);
        elseif strcmp(opt_est.val,'REG')
            err_valid(a_ord,b_ord) =  sum((pred_valid.OutputData - y_valid').^2) / n_train_sam * sqrt(a_ord);
        end
end
mini = find(err_valid == min(err_valid(2:end)));
opt_est.aord = mini;
fprintf('%s%i\n','Chosen order: n_a = ',opt_est.aord);
