function err_reg = model_selection_computation(y_real,y_est,n_param,opt_est)

assert(length(y_real) == length(y_est));
n_sample = length(y_est);
MSE = (y_real - y_est)'*(y_real - y_est) / (n_sample - 1);

if strcmp(opt_est.val,'AIC')
    err_reg = log(MSE) + 2 * n_param / n_sample;
elseif strcmp(opt_est.val,'BIC')
    err_reg =  log(MSE) + n_param * log(n_sample);
elseif strcmp(opt_est.val,'FPE')
    err_reg =  log(MSE) * (1 - 2 * n_sample / n_param);
elseif strcmp(opt_est.val,'MSE')
    err_reg = MSE;
else
    fprintf('%s\n','Nonexisting option for order estimation');
    return;
end

