function [network y] = rn_test(network,u,opt_est)

% Method for testing a multiple input single output RN (train by RN_train)
% Note: the method also updates the internal states

% INPUT
% network: previously generated by RN_init
% u: input to test
% opt an option structure with:
%     direct: includes (1) or escludes (0) the direct connections

%OUTPUT
% network: with the following modified elements:
%     x: internal states
%     y: estimated output

% Output initialization
n_sample = size(u,2);
y = zeros(n_sample,1);

% reconstruction with tpreviously trained RN
for i=1:n_sample
    network.x = feval(network.f, network.W * network.x + network.W_in * u(:,i));
    if opt_est.direct == 0
        y(i) = feval(network.f_out,network.W_out * network.x);
    else
        y(i) = feval(network.f_out,network.W_out * [network.x; u(:,i)]);
    end
end
